#import "BackpackAppDelegate.h"
#import "ASIHTTPRequest.h"
#import "SBJson.h"
#import "AuthenticateWindowController.h"
#import "MainViewController.h"
#import "EMKeychainItem.h"

@implementation BackpackAppDelegate

@synthesize window;
@synthesize saveUserToken, tempUserToken;

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
}

- (void)setMainViewController:(MainViewController*)vc {
    mainViewController = vc;
}

- (void)openAuthWindow {
    
    // NSString *userToken = [[NSUserDefaults standardUserDefaults] stringForKey:@"InstaToken"];
    // CHECK THAT USER IS NOT AUTHENTICATED ALREADY
    
    myWindowController = [[AuthenticateWindowController alloc] initWithWindowNibName:@"AuthenticateWindow"];
    [[myWindowController window] makeKeyAndOrderFront:self];
        
    
}

- (void)openMainView {
    
    if (myWindowController) {
        [[myWindowController window] close];
        [myWindowController release];
	}
    
    [mainViewController showAuthenticated];
}

- (void)closeEndView {
    
    // USER TO START SCREEN
    [mainViewController showStartView];
}

// global controls
- (IBAction)logoutCurrentUser:(id)sender {
    
    // DELETE all references
    NSHTTPCookie *cookie;
    NSHTTPCookieStorage *cookieJar = [NSHTTPCookieStorage sharedHTTPCookieStorage];
    for (cookie in [cookieJar cookies]) {
        NSString *cookieDomain = [cookie domain];
        
        // Delete only instagram cookies from browser cache
        if ([cookieDomain isEqualToString:@"instagram.com"]) {
            // NSLog(@"cookie exists: %@", [cookie domain]);
            [cookieJar deleteCookie:cookie];
        }
        
    }
    
    
    tempUserToken = nil;
    
    // keychain
    NSString *currentUser = NSUserName();
    EMGenericKeychainItem *keychainItem = [EMGenericKeychainItem genericKeychainItemForService:@"Photoplank" withUsername:currentUser];
    [keychainItem removeFromKeychain];
    
    // and change view
    [self closeEndView];
}

@end
