#import <Cocoa/Cocoa.h>
#import "ASINetworkQueue.h"
#import "InstagramDataParser.h"
#import "InstagramDataParserDelegate.h"

@interface BackupViewController : NSViewController <InstagramDataParserDelegate> {
@private
    
    // IB elements
    IBOutlet NSView *startDownloadView;
    IBOutlet NSView *showProgressView;
    IBOutlet NSView *finishedDownloadView;
    
    // User profile page
    IBOutlet NSTextField *usernameField;
    IBOutlet NSTextField *userPhotoCount;
    IBOutlet NSTextField *userFollowsCount;
    IBOutlet NSTextField *userFollowerCount;
    
    // Progress
    IBOutlet NSTextField *downloadProgressMessage;
    IBOutlet NSProgressIndicator *downloadProgressIndicator;
    
    IBOutlet NSTextField *messageField;
    
    // filecontrols
    NSOpenPanel *openPanel;
    NSSavePanel *savePanel;
    NSString *saveFolderPath;
    
    ASINetworkQueue *networkQueue;
    InstagramDataParser *instaParser;
}

@property (retain, nonatomic) IBOutlet NSView *startDownloadView;
@property (retain, nonatomic) IBOutlet NSView *showProgressView;
@property (retain, nonatomic) IBOutlet NSView *finishedDownloadView;

@property (retain, nonatomic) IBOutlet NSTextField *usernameField;
@property (retain, nonatomic) IBOutlet NSTextField *userPhotoCount;
@property (retain, nonatomic) IBOutlet NSTextField *userFollowsCount;
@property (retain, nonatomic) IBOutlet NSTextField *userFollowerCount;

@property (retain, nonatomic) IBOutlet NSTextField *downloadProgressMessage;
@property (retain, nonatomic) IBOutlet NSProgressIndicator *downloadProgressIndicator;

@property (retain) ASINetworkQueue *networkQueue;
@property (retain, nonatomic) InstagramDataParser *instaParser;

@property (retain, nonatomic) NSString *saveFolderPath;

// Pre-start
- (IBAction)backupClicked:(id)sender;
- (IBAction)selectLocation:(id)sender;
// during backup
- (IBAction)cancelBackup:(id)sender;
// after
- (IBAction)showInFinder:(id)sender;
- (IBAction)startAgain:(id)sender;

// profile

- (void)showUserDetails;
- (void)userInfoLoaded;
- (void)backupPhotos;
- (void)photoListGathered;

- (void)requestFinished:(ASIHTTPRequest *)request;
- (void)requestFailed:(ASIHTTPRequest *)request;
- (void)queueFinished:(ASINetworkQueue *)queue;
@end
