#import <Foundation/Foundation.h>
#import "InstagramDataParserDelegate.h"

@interface InstagramDataParser : NSObject {

id <InstagramDataParserDelegate> delegate;
    
@public
    // user properties
    NSString *username;
    NSNumber *photoCount;
    NSNumber *followsCount;
    NSNumber *followerCount;
    
@private
    
    NSArray *photoUrlArray;
    NSURL *pagedURL;
    
    NSURL *userInfoURL;
    NSURL *photoInfoURL;
    
    // token
    NSString *userToken;
}

// delegate properties
@property (nonatomic, assign) id <InstagramDataParserDelegate> delegate;

// retained
@property (retain, nonatomic) NSArray *photoUrlArray;
@property (retain, nonatomic) NSURL *pagedURL;

@property (retain) NSURL *photoInfoURL;

// callbacks
@property (assign) SEL didFinishGathering;
@property (assign) SEL didFinishUserInfo;

// data
@property (retain, nonatomic) NSString *username;
@property (retain, nonatomic) NSNumber *photoCount;
@property (retain, nonatomic) NSNumber *followsCount;
@property (retain, nonatomic) NSNumber *followerCount;

// nicer auth
-(void)authenticateUser;

// for photo fetching
-(void)gatherData;
-(void)requestAndParse:(NSURL *)address;
-(void)setToken:(NSString*)token;

// user data
-(void)getUserInfo;

// getters
-(NSArray*)getPhotolist;

@end
