#import "InstagramDataParser.h"
#import "ASIHTTPRequest.h"
#import "SBJson.h"

@implementation InstagramDataParser

@synthesize photoUrlArray, pagedURL, photoInfoURL;
@synthesize username, photoCount, followsCount, followerCount;
@synthesize didFinishUserInfo, didFinishGathering;
@synthesize delegate;

- (id)init {
    self = [super init];
    if (self) {
    }
    return self;
}

// AUTH

-(void)authenticateUser {
    NSString * authPath = @"https://instagram.com/oauth/authorize/?client_id=5ffaa92f34a14a76b6b4927a223a7580&redirect_uri=http://www.amanata.com/instagram/&response_type=token&username=joonas_&password=fuckit&grant_type=password";
    NSURL *authURL = [NSURL URLWithString:authPath];
    
    ASIHTTPRequest * authTest = [ASIHTTPRequest requestWithURL:authURL];
    [authTest startSynchronous];
    // NSString *response = [authTest responseString];
    // NSLog(@"%@", response);
}

// GETTERS

-(NSArray*)getPhotolist {
    return [self photoUrlArray];
}

-(void)setToken:(NSString*)token {
    userToken = token;
    userInfoURL = [NSURL URLWithString:[NSString stringWithFormat:@"https://api.instagram.com/v1/users/self/?access_token=%@", token]];
    self.photoInfoURL = [NSURL URLWithString:[NSString stringWithFormat:@"https://api.instagram.com/v1/users/self/media/recent/?access_token=%@", token]];
}

// METHODS

-(void)getUserInfo {
    
    ASIHTTPRequest *selfRequest = [ASIHTTPRequest requestWithURL:userInfoURL];
    [selfRequest startSynchronous];
    NSString *response = [selfRequest responseString];
    // NSLog(@"%@", response);
    
    // LETS PARSE USER DATA
    NSDictionary *results = [response JSONValue];
    // TODO: Handle if instagram is down or not data available.
    
    // STATUS CODES: 200 OK, 400 AUTH UNSUCCESSFUL
    // NSString *statusCode = [[results objectForKey:@"meta"] valueForKey:@"code"];
    // NSLog(@"status code: %@", statusCode);
    
    NSAlert *alert = [[NSAlert alloc] init];
    [alert addButtonWithTitle:@"Retry"];
    [alert addButtonWithTitle:@"Cancel"];
    [alert setMessageText:@"Authentication unsuccessful"];
    [alert setInformativeText:@"Retry again."];
    [alert setAlertStyle:NSWarningAlertStyle];
    // [alert runModal];
    
    NSDictionary *countResults = [[results objectForKey:@"data"] valueForKey:@"counts"];
    username = [[results objectForKey:@"data"] valueForKey:@"username"];
    photoCount = [countResults objectForKey:@"media"];
    followsCount = [countResults objectForKey:@"follows"];
    followerCount = [countResults objectForKey:@"followed_by"];
    
    // DEFINE finished stricter
    if ([delegate respondsToSelector: didFinishUserInfo]) {
        [delegate performSelector:didFinishUserInfo];
    }
}

-(void)gatherData {
    [self requestAndParse:photoInfoURL];
}

- (void)requestAndParse:(NSURL *)url {
    // NSLog(@"requesting data from instagram..");
    // TODO: request failed / not OK response
    
    ASIHTTPRequest *request = [ASIHTTPRequest requestWithURL:url];
    [request setDidFinishSelector:@selector(requestFinished:)];
    [request setDelegate:self];
    [request startAsynchronous];
}

- (void)requestFinished:(ASIHTTPRequest *)request {

    NSString *nextURL= nil;
    NSError *error = [request error];
    if (!error) {
        NSString *jsonString = [request responseString];
        NSDictionary *results = [jsonString JSONValue];
        
        // LETS GRAB SOME INFO
        nextURL = [[results objectForKey:@"pagination"] valueForKey:@"next_url"];
        if (nextURL)
            [self setPagedURL:[NSURL URLWithString:nextURL]];
    }
    
    // SOME BASIC PARSING
    NSString *jsonString = [request responseString];
    NSDictionary *results = [jsonString JSONValue];
    
    // MERGE ARRAYS
    NSArray *newPhotos = [[results objectForKey:@"data"] valueForKey:@"images"];
    // NSLog(@"array: %@", newPhotos);
    
    NSMutableSet *set = [NSMutableSet setWithArray:photoUrlArray];
    [set addObjectsFromArray:newPhotos];
    
    [self setPhotoUrlArray:[set allObjects]];
    
    if (nextURL) {
        // load more data
        [self requestAndParse:pagedURL];
    } else {
         //NSLog(@"Finished");
        
        // DEFINE finished stricter
        if ([delegate respondsToSelector: didFinishGathering]) {
            [delegate performSelector:didFinishGathering withObject:photoUrlArray];
        }
    }
    
}
    

@end
