#import "MainViewController.h"
#import "BackpackAppDelegate.h"

#import "StartViewController.h"
#import "BackupViewController.h"

#import "EMKeychainItem.h"

@implementation MainViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
    }
    
    return self;
}

- (void)awakeFromNib {
    
    BackpackAppDelegate *appDelegate = (BackpackAppDelegate *)[[NSApplication sharedApplication] delegate];
    [appDelegate setMainViewController:self];
    
    // AUTH CHECK
    // IF IT DOES, ENTER NEXT SCREEN DIRECTLY
    NSString *currentUser = NSUserName();
    EMGenericKeychainItem *keychainItem = [EMGenericKeychainItem genericKeychainItemForService:@"Photoplank" withUsername:currentUser];
    // NSLog(@"%@", keychainItem.password);
    
    if (keychainItem) {
        // success
        BackpackAppDelegate *appDelegate = (BackpackAppDelegate *)[[NSApplication sharedApplication] delegate];
        [appDelegate setTempUserToken:keychainItem.password];
        
        backupController = [[BackupViewController alloc] initWithNibName:@"BackupViewController" bundle:nil];
        [[self.view animator] replaceSubview:mainView with:[backupController view]];
        CGRect r = [[backupController view] frame];
        r.origin.y = 14.0f;
        //[[backupController view] setFrame:r];
        
    } else {
        startViewController = [[StartViewController alloc] initWithNibName:@"StartView" bundle:nil];
        [[self view] replaceSubview:mainView with:[startViewController view]];
        // adjust the added subview position
        CGRect r = [[startViewController view] frame];
        r.origin.y = 14.0f;
        //[[startViewController view] setFrame:r];
    }
}

-(IBAction) authenticateFinished: (id) sender {
    
    BackpackAppDelegate *appDelegate = (BackpackAppDelegate *)[[NSApplication sharedApplication] delegate];
    [appDelegate openMainView];
}

-(void) showAuthenticated {
    backupController = [[BackupViewController alloc] initWithNibName:@"BackupViewController" bundle:nil];
    [[self.view animator] replaceSubview:[startViewController view] with:[backupController view]];
	// [[self view] replaceSubview:[startViewController view] with:[backupController view]];
    // adjust the added subview position
    CGRect r = [[backupController view] frame];
    r.origin.y = 14.0f;
    //[[backupController view] setFrame:r];
}

-(void) showStartView {
    startViewController = [[StartViewController alloc] initWithNibName:@"StartView" bundle:nil];
	[[self view] replaceSubview:[backupController view] with:[startViewController view]];
    // adjust the added subview position
    CGRect r = [[startViewController view] frame];
    r.origin.y = 14.0f;
    //[[startViewController view] setFrame:r];
}

- (void)dealloc
{
    [startViewController release];
    [backupController release];
    [super dealloc];
}

@end
